import React from 'react';
import { PageLoading } from '@ant-design/pro-layout';
import { Redirect, connect, ConnectProps, StateType, history, Link } from 'umi';
import { stringify } from 'querystring';
import { ConnectState } from '@/models/connect';
import { CurrentUser } from '@/models/user';
import { getCookie } from '@/utils/method';
import { Result, Button } from 'antd';

interface SecurityLayoutProps extends ConnectProps {
  loading?: boolean;
  currentUser?: CurrentUser;
  login?: StateType;
}

interface SecurityLayoutState {
  token: String;
  isReady: boolean;
}

class SecurityLayout extends React.Component<SecurityLayoutProps, SecurityLayoutState> {
  state: SecurityLayoutState = {
    isReady: false,
    token: '',
  };

  // componentDidMount() {
  // console.log('componentDidMount触发了23333333');

  //   this.setState({
  //     isReady: true,
  //   });
  //   const { dispatch, login } = this.props;
  //   console.log('安全登录中');
  //   console.log(login);
  //   if (dispatch && !!login?.userName && !!login?.password) {
  //     dispatch({
  //       type: 'user/fetchCurrent',
  //       playload: {
  //         userName: login.userName,
  //         password: login.password,
  //       },
  //     });
  //   } else {
  //     history.push('/user/login');
  //   }
  // }

  render() {
    const { children, loading } = this.props;
    // You can replace it to your authentication rule (such as check token exists)
    // 你可以把它替换成你自己的登录认证规则（比如判断 token 是否存在）

    const perList = [
      {
        path: '/UserManagement/LIFEUserManagement',
        key: '1',
      },
      {
        path: '/UserManagement/ServiceProviderManagement',
        key: '8',
      },
      {
        path: '/PropertyManagement',
        key: '15',
      },
      {
        path: '/CommercialService/CommunityMaintenance',
        key: '17',
      },
      {
        path: '/CommercialService/OwnerComplaints',
        key: '20',
      },
      {
        path: '/CommercialService/ProblemFeedback',
        key: '23',
      },
      {
        path: '/CommercialService/RenovationApplication',
        key: '26',
      },
      {
        path: '/CommercialService/AccessCardApplication',
        key: '29',
      },
      {
        path: '/CommercialService/ReportOnline',
        key: '33',
      },
      {
        path: '/CommercialService/ShelfLifeService',
        key: '36',
      },
    ];

    const permission = JSON.parse(localStorage.getItem('permission') || '[]');
    console.log('验证权限' + location.pathname);
    console.log('拿取所有权限' + permission);
    // 判断是否有权限
    // if (perList.indexOf("")) {

    // }

    let perObj = perList.filter((obj) => {
      return obj.path === location.pathname;
    });

    console.log(perObj);

    if (perObj.length !== 0) {
      if (permission.indexOf(perObj[0].key) < 0) {
        console.log('无权限');
        history.push('/403');
      }
    }

    // const isLogin = currentUser && currentUser.name;//isLogin为关键点
    var isLogin = false;
    if (getCookie('token').length != 0) {
      isLogin = true;
    }

    const queryString = stringify({
      redirect: window.location.href,
    });

    if (!isLogin && loading) {
      // console.log("页面加载")
      return <PageLoading />;
    }
    if (!isLogin && window.location.pathname !== '/user/login') {
      return <Redirect to={`/user/login?${queryString}`} />;
    }
    return children;
  }
}

export default connect(({ user, loading, login }: ConnectState) => ({
  currentUser: user.currentUser,
  loading: loading.models.user,
  login: login,
}))(SecurityLayout);
